
// ALIEN ASSAULT (tm) Written by Johan Peitz (c) 1996 CROWFOOT SOFtWARE (r)

//  		      	     Play or (and) die!


int GAMESPEED=1;

// egna includds
#include "opers.cpp"
#include "aliengfx.cpp"
#include "map.cpp"
#include "object.cpp"
#include "keyhand2.cpp"
// borlands includds
#include <conio.h>
#include <dos.h>
#include <string.h>
#include <fstream.h>
#include <iostream.h>
#include <stdlib.h>

// FUNKTIONER

void credits();                       	  // visar krediterna
int title();                         	  // visar titelbilden
void newlevel(int &x,int &y);     	  // inintierar ett nytt level
void drawscreen(int ir,int i,int tx,int ty,int water,int r,int ke);// ritar skrmen beroende p ox,oy
void initgame();		  	  // initierar spelet,reserverar minne
void killgame();			  // frigr allt minne
void pause();			  	  // pausar spelet...
void wait();    			  // vntar i enlighet med GAMESPEED
void options();
void showhandmap();
void playthegame();			  // spela spelet...
int checkhit(int px,int py,int rikt,int &bx,int &by);// kollar om man skjuter p ngt
void gameover();
void finish();
void shadowwrite(char* txt,int x,int y,int col,word FONT,word DEST);


// FUNKTIONER TILL ALIENSEN

void movealiens(int px,int py);		  // gissa det ni!
int seehero(int ax,int ay,int px,int py); // ser aliensen spelaren?
int adjust(int ox,int oy,int xy,int &ax,int &ay);  // korrigerar aliensarnas position

//  FUNKTIONER TILL DATOREN

void bright(int x,int y,int length);
void computer(int px,int py);	       	  // visar datorn...

// GLOBALA VARIABLER

unsigned char *VGA2 = (unsigned char *) MK_FP(0xA000, 0)+4;

word BLadr,OBadr,PLadr;                   // adresser till block och objekt
byte * BLblo;                          // block till ovanstende
byte * OBblo;                          //
byte * PLblo;                          //

word VR;				  // adress till VR-skrmen
byte * SCR;                            // block till ovanstende

word SYSFNT;				  // adress till SYS-fonten
byte * FNT;                            // block till ovanstende

pal  PAL,pausPAL,cpuPAL,tPAL,offPAL;	  // en palett
pal  redPAL;
pointpal shadowPAL;                       // frgernas skuggor

map  level,see;			          // kartan...
map  equip;			          // saker p golvet

int  eggenergy=10;    		          // ggets energi
int  objective=0;     		          // har jag klarat level-uppdraget?
int  light;			  	  // r lyset p?
int  weapon;				  // vilket vapen anvnds?
int  ownweapon[4];			  // vilka vapen gs???
int  hurt,hrate;			  // skadad,skadebild,dd?
int  fire,firerate,frat,fired; 		  // skjuter hjlten?
int  ammo,keys,handmap;			  // gunpower,nycklar,handmappen
int  fxy[8][2];                           // vart skjuts det
int  energy,showenergy;		  	  // ens energi
int  securetycard,clips;		  // securetycard... :), ammoclips
int  lives,immortal,visible;		  // antal liv, immortal
int  bana,killed;			  // level, hur mnga ddat?
long score,money;			  // pong & stlar
int  firewall;				  // r brandvggen ppnad???
int  sta=1;				  // stuffanimrate;
int  stamax=1;				  // stuffanimrate;
int  ljud=0;				  // sound OFF!
object stuff[100];			  // aliens...
int  timeleft=-1;			  // tid kvar innan BOOOM!


// LADIES AND GENTLEMEN... the GAME!


void main()
{
  saveoldhandler();			  // sparar den vanliga tangentinterrupten
  newhandler();	     	    		  // anvnder den nya tangentinterrupten

  mode(19);				  // initierar grafik MCGA

  credits();                              // visar krediterna
  if (title()==57)                         // visar titelbilden
    playthegame();			  // spela spelet...


  restorehandler();			  // hmtar den vanliga tangentinterrupten
}

// FUNKTIONER

void gameover()
{
  int k;

  setpalette(0,0,0);
  loadcel("gameover.cel",VGA2,PAL);
  do { delay(1); wait(); } while (fadein(PAL)>0);

  k=KEY;
  do { k=KEY; } while(k!=1 && k!=57);
  do { delay(1); wait(); } while (fadeout(63,0,0)>0);
  do { delay(1); wait(); } while (fadeout(0,0,0)>0);
}

void finish()
{
  int k;

  setpalette(0,0,0);
  loadcel("welldone.cel",VGA2,PAL);
  do { delay(1); wait(); } while (fadein(PAL)>0);

  shadowwrite("You teleport abord your ship and",20,120,111,SYSFNT,VGA);
  shadowwrite("relax. The mission was carried out.",20,130,111,SYSFNT,VGA);
  shadowwrite("Humans can now relax since the alien",20,140,111,SYSFNT,VGA);
  shadowwrite("threat is gone.",20,150,111,SYSFNT,VGA);

  k=KEY;
  do { k=KEY; } while(k!=1 && k!=57);
  shadowwrite("Or did some survive?",20,170,111,SYSFNT,VGA);

  int x=-20,y=170,anim=0;

  screencopy(VGA,VR);
  do {
    add(anim,1,0,3); x+=3;
    wait();
    wait();
    screencopy(VR,VGA);
    puticon_M(anim*8+3,x,y,VGA,OBadr);
  } while (fadeout(0,63,0)>0);
  do { delay(1); wait(); } while (fadeout(0,0,0)>0);
}

void wait()
{
  if (GAMESPEED>0)
    for(int i=0;i<GAMESPEED;i++)
      waitvbl();
}

int adjust(int ox,int oy,int xy,int &ax,int &ay)
// justerar alienens postion s att de inte springer i vggen
{
  int w,bl1,bl2,bl3,bl4;

  bl1=level.cblock(ax,ay);           // lser in vilka block som r
  bl2=level.cblock(ax+23,ay);        // under alienens fyra hrn
  bl3=level.cblock(ax+23,ay+19);
  bl4=level.cblock(ax,ay+19);
  w=0;                               // om det r vgg s rtta till x och y
  if (bl1<52 || bl2<52 || bl3<52 || bl4<52 || bl1==60 || bl2==60 || bl3==60 || bl4==60)
  {
    w=1;
    if (xy==1) ax=ox;
    else ay=oy;
  }
  return(w);
}

int seehero(int ax,int ay,int px,int py)
// kollar om alienen ser hjlten
{
  int dist=5;                // lngden p synfltet
  int i;
  int dx=0;
  int dy=0;
  int s=0;

  if (ax<px) dx=1;          // justerar s att alienen tittar MOT hjlten
  if (ax>px) dx=-1;
  if (ay<py) dy=1;
  if (ay>py) dy=-1;

  ax=ax/24;
  ay=ay/20;

  i=0;
  do {
    if (see.block(ax,ay)==0 && s==0) s=1;
    if (see.block(ax,ay)<52 && s==0) s=2;
    ax=ax+dx;
    ay=ay+dy;
    i++;
  } while(i<dist);

  return(s);
}

void movealiens(int px,int py)
// flyttar runt aliensen + animerar dem
{
  int wall,sped,r,ax,ay,tx,ty,x,y,i,ti,j,bl1,bl2,bl3,bl4;

  add(sta,1,1,stamax);             // fixar animationshastighet
  see.cchange(px,py,0);            // markerar var hjlten r p banan
  see.cchange(px+23,py,0);
  see.cchange(px+23,py+19,0);
  see.cchange(px,py+19,0);
  hurt=0;

  j=0;
  do {			          // rasslar igenom all 100 aliensen
    if (stuff[j].exist==1) {      // utfrs bara om alienen lever
      sped=stuff[j].speed;
      ax=stuff[j].x;
      ay=stuff[j].y;
      tx=stuff[j].x;
      ty=stuff[j].y;
      if (abs(px-ax)<24 && abs(py-ay)<20)    // kan alienen skada hjlten?
      {
	hurt=1;
	if (immortal==0) energy=max(energy-1-((stuff[j].type+1) << 1),0);   // minska energi
      }
      else
      {
	if (seehero(tx,ty,px,py)==1)    // om aliensen ser spelaren g ditt
	{
	  if (tx>px) stuff[j].x=stuff[j].x-sped;
	  if (tx<px) stuff[j].x=stuff[j].x+sped;
	  wall=adjust(tx,ty,1,stuff[j].x,stuff[j].y);
	  tx=stuff[j].x;
	  if (ty>py) stuff[j].y=stuff[j].y-sped;
	  if (ty<py) stuff[j].y=stuff[j].y+sped;
	  wall=adjust(tx,ty,0,stuff[j].x,stuff[j].y);
	}
	else                      // annars fortstt i aktuell riktning...
	{
	  r=stuff[j].rikt;
	  if (r==2 || r==3 || r==4) stuff[j].x=stuff[j].x+sped;
	  if (r==6 || r==7 || r==8) stuff[j].x=stuff[j].x-sped;
	  wall=adjust(tx,ty,1,stuff[j].x,stuff[j].y);
	  tx=stuff[j].x;
	  if (r==8 || r==1 || r==2) stuff[j].y=stuff[j].y-sped;
	  if (r==4 || r==5 || r==6) stuff[j].y=stuff[j].y+sped;
	  wall=wall+adjust(tx,ty,0,stuff[j].x,stuff[j].y);
	  if (wall>0) { stuff[j].image=random(8)+1; stuff[j].rikt=stuff[j].image; stuff[j].image=stuff[j].image+stuff[j].type*39;}
	}
	if (sta==1) add(stuff[j].anim,1,0,3);   // byter animationsbild
	tx=stuff[j].x;
	ty=stuff[j].y;
				    // rknar ut vilken bild alienen har
	if (ax==tx && ay<ty)
	  { stuff[j].image=5+(stuff[j].anim<<3)+stuff[j].type*39; stuff[j].rikt=5; }
	if (ax>tx && ay<ty)
	  { stuff[j].image=6+(stuff[j].anim<<3)+stuff[j].type*39; stuff[j].rikt=6; }
	if (ax>tx && ay==ty)
	  { stuff[j].image=7+(stuff[j].anim<<3)+stuff[j].type*39; stuff[j].rikt=7; }
	if (ax>tx && ay>ty)
	  { stuff[j].image=8+(stuff[j].anim<<3)+stuff[j].type*39; stuff[j].rikt=8; }
	if (ax==tx && ay>ty)
	  { stuff[j].image=1+(stuff[j].anim<<3)+stuff[j].type*39; stuff[j].rikt=1; }
	if (ax<tx && ay>ty)
	  { stuff[j].image=2+(stuff[j].anim<<3)+stuff[j].type*39; stuff[j].rikt=2; }
	if (ax<tx && ay==ty)
	  { stuff[j].image=3+(stuff[j].anim<<3)+stuff[j].type*39; stuff[j].rikt=3; }
	if (ax<tx && ay<ty)
	  { stuff[j].image=4+(stuff[j].anim<<3)+stuff[j].type*39; stuff[j].rikt=4; }
      }
    }
    j++;
  } while(j<100);					// tar bort hjlten ur synen

  see.cchange(px,py,53);
  see.cchange(px+23,py,53);
  see.cchange(px+23,py+19,53);
  see.cchange(px,py+19,53);
}

void bright(int x,int y,int length)
{
  int xx,yy,pix;

  length=length<<3;
  for(xx=x;xx<x+length;xx++)
    for(yy=y;yy<y+7;yy++)
    {
      pix=getpixel(xx,yy,VR);
      if (pix>239) putpixel(xx,yy,pix+3,VR);
     }
}


void computer(int px,int py)
// startar datorn och dess funktioner
{
  byte far* CPblk;
  word CP;

  int moderev=0,modeswi=0;
  int ky,x,y,n,tryck=0;
  int val=6,pos;

// fixar priserna...
  int ypos[9]={60,70,80,90,100,130,140,150,170};               // sista = main
  int pris[9]={500*bana,1500,1500,2500,10000,5300,8700,12700,0};
  int sold[9]={handmap,0,0,0,0,ownweapon[1],ownweapon[2],ownweapon[3],0};

  makevirt(CP,CPblk);
  screencopy(VGA,CP);

  screencopy(VGA,VR);
  do { delay(1); wait(); } while (fadein(cpuPAL)>0);
  storepalette(tPAL);
  for(x=240;x<256;x++)
  {
    tPAL[x][0]=0;                 // gr en ny bl palett
    tPAL[x][1]=0;
    tPAL[x][2]=0;
  }
  recallpalette(tPAL);

  do {
    screencopy(CP,VR);
    for(int i=0;i<9;i++)
      puticon_M(i+79,50+i*24,30,VR,PLadr);    // CEC

    write("Show$Levelmap",80,70,0,SYSFNT,VR);
    write("Reverse$Oneways",80,80,0,SYSFNT,VR);
    write("Switch$Firewalls",80,90,0,SYSFNT,VR);
    write("Lights$Are",80,100,0,SYSFNT,VR);
    write("Buy$Items/Weapons",80,110,0,SYSFNT,VR);
    write("Statistics",80,120,0,SYSFNT,VR);
    write("Logout",80,130,0,SYSFNT,VR);

    if (light==1) write("On",168,100,0,SYSFNT,VR);
    else write("Off",168,100,0,SYSFNT,VR);

    if (moderev==1) write("%",50,80,242,SYSFNT,VR);
    if (modeswi==1) write("%",50,90,242,SYSFNT,VR);

    puticon_M(99,65,63+val*10,VR,PLadr);
    bright(80,70+val*10,20);

    if (val==2 && securetycard==0)
    {
      write("ACCESS$DENIED",104,150,240,SYSFNT,VR);
      write("SECURETYCARD$NEEDED",80,158,242,SYSFNT,VR);
    }


    screencopy(VR,VGA);
    do { delay(1); wait(); } while (fadein(cpuPAL)>0);

    ky=KEY; tryck=0;
    if (ky==28 || ky==56) tryck=1;
    if (ky==1) val=6;
    if (ky==72) add(val,-1,0,6);
    if (ky==76 || ky==80) add(val,1,0,6);
    if (tryck==1 && val==3)                     // lys p/av
      add(light,1,0,1);
    if (tryck==1 && val==0)                     // visar kartan
    {
      do { delay(1); wait(); } while (fadein(tPAL)>0);
      screencopy(CP,VR);
      for(x=0;x<40;x++)
	for(y=0;y<40;y++) {
	  if (level.block(x,y)<52) bar(25+x*4,20+y*4,28+x*4,23+y*4,250,VR);
	  if (level.block(x,y)==19 || level.block(x,y)==18) bar(25+x*4,20+y*4,28+x*4,23+y*4,254,VR);
	}
      write("Level",220,50,0,SYSFNT,VR);
      type(bana,196,50,0,SYSFNT,VR);
      bright(220,50,7);
      puticon_M(99,205,143,VR,PLadr);
      write("Main$Menu",220,150,0,SYSFNT,VR);
      bright(220,150,9);
      screencopy(VR,VGA);

      do { delay(1); wait(); } while (fadein(cpuPAL)>0);

      while (ky==KEY);
      n=1; x=px/24; y=py/20;
      do {
	wait(); wait(); wait(); wait();
	screencopy(VR,VGA);
	bar(26+x*4,21+y*4,27+x*4,22+y*4,240,VGA);
	box(26+x*4-n,21+y*4-n,27+x*4+n,22+y*4+n,254,VGA);
	add(n,1,1,3);
      } while (KEY!=28 && KEY!=56);
      do { delay(1); wait(); } while (fadein(tPAL)>0);
      screencopy(VR,VGA);
    }
    if (tryck==1 && val==5)                     // visar kartan
    {
      n=energy/3.48;

      do { delay(1); wait(); } while (fadein(tPAL)>0);
      screencopy(CP,VR);
      write("Level",40,20,0,SYSFNT,VR);
      write("Score",40,30,0,SYSFNT,VR);
      write("Keys",40,40,0,SYSFNT,VR);
      write("Credits",40,50,0,SYSFNT,VR);
      write("Clips",40,60,0,SYSFNT,VR);
      write("Health",40,70,0,SYSFNT,VR);
      write("Lives",40,80,0,SYSFNT,VR);
      write("Rounds$Fired",40,90,0,SYSFNT,VR);
      write("Aliens$Killed",40,100,0,SYSFNT,VR);
      write("Weapons:",30,120,0,SYSFNT,VR);
      write("Semi-Automatic$Gun",40,130,ownweapon[0]*7+247,SYSFNT,VR);
      write("Rapid$Twin$Rifle",40,140,ownweapon[1]*7+247,SYSFNT,VR);
      write("Fire$Archer",40,150,ownweapon[2]*7+247,SYSFNT,VR);
      write("Plasma$Launcher",40,160,ownweapon[3]*7+247,SYSFNT,VR);

      type(bana,120,20,0,SYSFNT,VR);
      type(score,120,30,0,SYSFNT,VR);
      type(keys,120,40,0,SYSFNT,VR);
      type(money,120,50,0,SYSFNT,VR);
      type(clips,120,60,0,SYSFNT,VR);
      type(n,120,70,0,SYSFNT,VR); 	write("&",200,70,0,SYSFNT,VR);
      type(lives,120,80,0,SYSFNT,VR);
      type(fired,120,90,0,SYSFNT,VR);
      type(killed,120,100,0,SYSFNT,VR);

      puticon_M(99,205,153,VR,PLadr);
      write("Main$Menu",220,160,0,SYSFNT,VR);
      bright(220,160,9);
      screencopy(VR,VGA);

      do { delay(1); wait(); } while (fadein(cpuPAL)>0);

      while (ky==KEY);
      while (KEY!=28 && KEY!=56);
      do { delay(1); wait(); } while (fadein(tPAL)>0);
      screencopy(VR,VGA);
    }
    if (tryck==1 && val==4)                     // shoppingtime
    {
      do { delay(1); wait(); } while (fadein(tPAL)>0);
      pos=8;
      do {
	screencopy(CP,VR);
	write("Crowfoot$Online$Store",76,15,242,SYSFNT,VR);
	write("Credits",60,30,0,SYSFNT,VR); type(money,180,30,0,SYSFNT,VR); bright(60,30,25);
	write("Misc.$Items",52,ypos[0]-10,0,SYSFNT,VR);
	write("Handmap",60,ypos[0],0,SYSFNT,VR);
	write("Set$Of$3$Keys",60,ypos[1],0,SYSFNT,VR);
	write("Ammoclip",60,ypos[2],0,SYSFNT,VR);
	write("First$Aid$Kit",60,ypos[3],0,SYSFNT,VR);
	write("Extra$life",60,ypos[4],0,SYSFNT,VR);
	write("Weapons:",52,ypos[5]-10,0,SYSFNT,VR);
	write("Rapid$Twin$Rifle",60,ypos[5],247,SYSFNT,VR);
	write("Fire$Archer",60,ypos[6],247,SYSFNT,VR);
	write("Plasma$Launcher",60,ypos[7],247,SYSFNT,VR);
	write("Main$Menu",60,ypos[8],0,SYSFNT,VR);
	for(n=0;n<8;n++)
	  if (sold[n]==0)
	    type(pris[n],180,ypos[n],0,SYSFNT,VR);
	  else
	    write("BOUGHT",212,ypos[n],0,SYSFNT,VR);

	puticon_M(99,45,ypos[pos]-7,VR,PLadr);
	bright(60,ypos[pos],26);
	screencopy(VR,VGA);
	do { delay(1); wait(); } while (fadein(cpuPAL)>0);

	ky=KEY; tryck=0;
	if (ky==28 || ky==56) tryck=1;
	if (ky==1) pos=8;
	if (ky==72) add(pos,-1,0,8);
	if (ky==76 || ky==80) add(pos,1,0,8);
	if (pos==7) pos=4;	// fixar s att man ej kan kpa vapnen
	if (pos==5) pos=8;

	if (tryck==1 && money>=pris[pos] && sold[pos]==0)
	{
	  money=money-pris[pos];
	  sold[pos]=1;
	  if (pos==0) handmap=1;
	  if (pos==1) keys+=3;
	  if (pos==2) clips++;
	  if (pos==3) energy=min(energy+100,348);
	  if (pos==4) lives++;
	  if (pos==5) { ownweapon[1]=1; ammo=348; }
	  if (pos==6) { ownweapon[2]=1; ammo=348; }
	  if (pos==7) { ownweapon[3]=1; ammo=348; }
	}

	while (ky==KEY);
      } while (tryck==0 || pos!=8);

      do { delay(1); wait(); } while (fadein(tPAL)>0);
      screencopy(VR,VGA);
    }
    if (tryck==1 && val==2 && securetycard==1)   // Swap firewalls
    {
      add(modeswi,1,0,1);
      for(x=0;x<40;x++)                      // reser & snker firewallsen
	for(y=0;y<40;y++)
	  if (level.block(x,y)==50)
	    level.change(x,y,81);
	  else if (level.block(x,y)==81)
	    level.change(x,y,50);
    }
    if (tryck==1 && val==1)                    // Change ONEWAYs
    {
      add(moderev,1,0,1);
      for(x=0;x<40;x++)                      // vrider alla riktpilar
	for(y=0;y<40;y++) {                  // med 180 grader
	  if (level.block(x,y)==88)
	    level.change(x,y,89);
	  else if (level.block(x,y)==89)
	    level.change(x,y,88);
	  if (level.block(x,y)==90)
	    level.change(x,y,91);
	  else if (level.block(x,y)==91)
	    level.change(x,y,90);
       }
    }
    while (ky==KEY);
  } while (tryck==0 || val!=6);

  do { delay(1); wait(); } while (fadein(tPAL)>0);
  screencopy(CP,VGA);
  if (light==1) do { delay(1); wait(); } while (fadein(PAL)>0);
  else do { delay(1); wait(); } while (fadein(offPAL)>0);

  killvirt(CPblk);
}

void options()
// visar options
{
  byte * TMPblk;
  byte * KEEPblk;
  word TMP;
  word KEEP;

  pal tpal;

  makevirt_C(TMP,TMPblk,60*320);
  loadcel("options.cel",TMPblk,tpal);

  makevirt(KEEP,KEEPblk);
  screencopy(VGA,KEEP);

  screencopy(VGA,VR);

  do { delay(1); wait(); } while (fadein(PAL)>0);

  for(int y=0;y<20;y++)
  {
    copymem(TMP,0,VR,(199-y)*320,(y+1)*160);
    wait();
    screencopy(VR,VGA);
  }

  for(y=20;y<60;y++)
  {
    copymem(KEEP,(y-20)*320,VR,0,(199-y)*160);
    copymem(TMP,0,VR,(199-y)*320,(y+1)*160);
    wait();
    screencopy(VR,VGA);
  }

  if (ljud==1) puticon_M(76,170,181,VGA,OBadr);
  puticon_M(77,208+8*GAMESPEED,172,VGA,OBadr);

  int g=0,l=0,color,sc=72;

  do {
    if (KEY==31 && l==0) { add(ljud,1,0,1); l=1; }
    if (Aleft==1 && g==0) { GAMESPEED=max(0,GAMESPEED-1); g=1; }
    if (Aright==1 && g==0) { GAMESPEED=min(9,GAMESPEED+1); g=1; }
    if (KEY>128) { l=0; g=0; }
    wait();
    memcpy(&VGA2[44800],&TMPblk[0],18880);
    if (ljud==1) puticon_M(76,170,181,VGA,OBadr);
    puticon_M(77,208+8*GAMESPEED,172,VGA,OBadr);
    add(sc,1,72,95); color=sc;
    for(y=226;y<306;y++)
    {
      add(color,1,72,95);
      line(y,153,y,162,color,VGA);
    }
  } while (KEY!=28 && KEY!=56 && KEY!=59);

  if (ljud==1) puticon_M(76,170,41,TMP,OBadr);
  puticon_M(77,208+8*GAMESPEED,32,TMP,OBadr);

  for(y=59;y>19;y--)
  {
    copymem(KEEP,(y-20)*320,VR,0,(199-y)*160);
    copymem(TMP,0,VR,(199-y)*320,(y+1)*160);
    wait();
    screencopy(VR,VGA);
  }

  for(y=19;y>=0;y--)
  {
    copymem(KEEP,57280,VR,57280,(20-y)*160);
    copymem(TMP,0,VR,(199-y)*320,(y+1)*160);
    wait();
    screencopy(VR,VGA);
  }

  killvirt(TMPblk);
  killvirt(KEEPblk);

  if (light==1) do { delay(1); wait(); } while (fadein(PAL)>0);
  else do { delay(1); wait(); } while (fadein(offPAL)>0);
}

void showhandmap(int px,int py)
// visar handmappen
{
  int x,y,n,i;
  char ky;

  screencopy(VGA,VR);

  do { delay(1); wait(); } while (fadein(cpuPAL)>0);

  for(x=0;x<40;x++)
    for(y=0;y<40;y++) {
      if (level.block(x,y)<52) bar(25+x*4,20+y*4,28+x*4,23+y*4,250,VGA);
      if (level.block(x,y)==19 || level.block(x,y)==18) bar(25+x*4,20+y*4,28+x*4,23+y*4,254,VGA);
    }
  write("Level",220,50,0,SYSFNT,VGA);
  type(bana,196,50,0,SYSFNT,VGA);
  bright(220,50,7);

  while (ky==KEY);

  n=1; i=1; x=px/24; y=py/20;
  do {
    wait(); wait(); wait(); wait();
    bar(26+x*4,21+y*4,27+x*4,22+y*4,240,VGA);
    box(26+x*4-n,21+y*4-n,27+x*4+n,22+y*4+n,254-i,VGA);
    add(n,1,1,3); add(i,1,1,4);
  } while (KEY!=28 && KEY!=56);

  screencopy(VR,VGA);
  if (light==1) do { delay(1); wait(); } while (fadein(PAL)>0);
  else do { delay(1); wait(); } while (fadein(offPAL)>0);
}

void pause()
// pausar spelet
{
  do { delay(3); wait(); } while (fadein(pausPAL)>0);

  do {} while (KEY!=153);      // ser till s att man inte pausar ur direkt
  do {} while (KEY!=25);
  do {} while (KEY!=153);
  if (light==1) do { delay(3); wait(); } while (fadein(PAL)>0);
  else do { delay(3); wait(); } while (fadein(offPAL)>0);
}

int checkhit(int px,int py,int rikt,int &bx,int &by)
// kollar om hjlten skjuter p ngon av aliensen
{
  int dist=6;
  int i,ax,ay,hx,hy;
  int dx=0;
  int dy=0;
  int s,t;

  if (rikt==1 || rikt==5 || rikt==8) dy=-1;      // justerar riktningen
  if (rikt==2 || rikt==5 || rikt==6) dx=1;
  if (rikt==3 || rikt==7 || rikt==6) dy=1;
  if (rikt==4 || rikt==7 || rikt==8) dx=-1;

  for(s=0;s<100;s++)
    if (stuff[s].exist==1) see.cchange(stuff[s].x+12,stuff[s].y+10,0);    // +

  ax=px/24+dx; ay=py/20+dy; s=0;
  i=0;
  do {
    if (see.block(ax,ay)<52 && s==0)
    {
      s=2; hx=ax; hy=ay;
      if (see.block(ax,ay)==46 ||
	  see.block(ax,ay)==47 ||
	  see.block(ax,ay)==48 ||
	  see.block(ax,ay)==49)	eggenergy-=1;
    }
    ax=ax+dx;
    ay=ay+dy;
    i++;
  } while(i<dist);

  i=0;
  do {
    if (stuff[i].exist==1) see.cchange(stuff[i].x,stuff[i].y,53);
    i++;
  } while (i<100);

  t=0; i=0;
  do {
    if (stuff[i].exist==1 && (stuff[i].x+12)/24==hx && (stuff[i].y+10)/20==hy && t==0)
      {
	s=1; t=1;                       // drar ner alienens energi
	bx=stuff[i].x-px-12;
	by=stuff[i].y-py-10;
	stuff[i].energy--;
	if (stuff[i].energy<0)
	{
	  stuff[i].exist=0;            // ddar alienen och ger den en
	  stuff[i].dead=random(4)+33;  // ddsbild
	  killed++;		       // kar killed (antal A ddade)
	  score=score+(stuff[i].type+1)*150;
	  money=money+(stuff[i].type+1)*30;
	}
      }
      i++;
    } while (i<100);
  return(s);
}

void shadowwrite(char* txt,int x,int y,int col,word FONT,word DEST)
// skriver ut txt till DEST
{
  int i=0;
  while (txt[i]!='\0')
  {
    text(txt[i],x+i*8+1,y+1,1,FONT,DEST);
    text(txt[i],x+i*8,y,col,FONT,DEST);
    i++;
  }
}

void briefing()
{
  cls(0,VGA);
  recallpalette(PAL);
  waitvbl();
  shadowwrite("LEVEL BRIEFING:",40,40,0,SYSFNT,VGA);
  if (bana==1)
  {
    shadowwrite("We have teleported you as deep",20,70,0,SYSFNT,VGA);
    shadowwrite("as it was possible into the starbase.",20,80,0,SYSFNT,VGA);
    shadowwrite("Proceed with caution to the level",20,90,0,SYSFNT,VGA);
    shadowwrite("teleporter to continue.",20,100,0,SYSFNT,VGA);
  }
  if (bana==2)
  {
    shadowwrite("Following level damaged by",20,70,0,SYSFNT,VGA);
    shadowwrite("malfunctioning selfdefence.",20,80,0,SYSFNT,VGA);
    shadowwrite("Proceed with caution to teleporter.",20,90,0,SYSFNT,VGA);
  }
  if (bana==3)
  {
    shadowwrite("Closing in on the aliens' activity",20,70,0,SYSFNT,VGA);
    shadowwrite("center. You must reach the teleport",20,80,0,SYSFNT,VGA);
    shadowwrite("in order to reach the final level.",20,90,0,SYSFNT,VGA);
  }
  if (bana==4)
  {
    shadowwrite("The evil aliens feed from a great",20,70,0,SYSFNT,VGA);
    shadowwrite("device hidden somewhere on this",20,80,0,SYSFNT,VGA);
    shadowwrite("level. You must find it and",20,90,0,SYSFNT,VGA);
    shadowwrite("deactivate it. Then escape back to",20,100,0,SYSFNT,VGA);
    shadowwrite("teleporter before the alien device",20,110,0,SYSFNT,VGA);
    shadowwrite("explodes.",20,120,0,SYSFNT,VGA);
  }

  shadowwrite("PRESS SPACEBAR TO CONTINUE...",40,180,0,SYSFNT,VGA);

  byte r=0,g=0,b=0;
  int rikt=1;

  do
  {
    wait();
    setcolor(0,r,g,b);
    r=r+rikt;
    if (r==33 || r==0) rikt=-rikt;
  }
  while (KEY!=57);

  do { delay(1); wait(); } while (fadeout(0,0,0)>0);
}

void playthegame()
// spelar spelet, skter hjltens rrelser och andra frehavanden
{
  int x,y,i;                       // spelarens x & y pos.
  int speed=2;                     // spelarens hastighet
  int x1,y1;                       // spelarens frra x & y pos.
  int image=3;                     // spelarens bild
  int anim=0;                      // animationsbild
  int bl1,bl2,bl3,bl4;             // hrn
  int up,down,left,right;          // riktingarna
  int h2o=0;                       // gr jag i vatten?
  int vat=0;                       // ringbildsrate
  int rippels=0;                   // ska det komma ringar
  int complete=0;                  // str jag p teleportern?
  int item=0;			   // vad finns under mig?

  up=0; down=0; left=0; right=0;         // ST STILL!
  energy=348; money=0; fire=0;
  hurt=0; hrate=53; ammo=348; frat=0;
  securetycard=0; clips=3; lives=2; keys=0;
  immortal=0; visible=1; bana=1;
  showenergy=energy; weapon=1;
  fired=0; killed=0;
  ownweapon[0]=1; ownweapon[1]=0; ownweapon[2]=0; ownweapon[3]=0;

  initgame();
  newlevel(x,y);
  do {
    movealiens(x,y);
    drawscreen(image,image+((anim>>2)<<2),x,y,h2o,rippels,keys);
    if (light==1) do { delay(1); wait(); } while (fadein(PAL)>0);
    else do { delay(1); wait(); } while (fadein(offPAL)>0);

    do {
      see=level;
      if (immortal>0) { add(visible,1,0,1); immortal--; }
      else visible=1;
      drawscreen(image,image+((anim>>2)<<2),x,y,h2o,rippels,keys);
      add(vat,1,0,5);
      if (vat==0) add(h2o,-1,40,43);
      x1=x; y1=y;

      if (timeleft>0) { timeleft--; fadein(redPAL); }
      if (timeleft==0) { lives=-1; energy=-1; }

      if (KEY==25) pause();

      if (Lctrl==0) speed=2;
      if (Lalt==0) fire=0;
      if (Aup==0) up=0;
      if (Adown==0) down=0;
      if (Aleft==0) left=0;
      if (Aright==0) right=0;
/*      if (NOKEY==199) { left=0; up=0; }
      if (NOKEY==201) { up=0; right=0; }
      if (NOKEY==207) { left=0; down=0; }
      if (NOKEY==209) { down=0; right=0; }
*/

/* fusk...
if (KEY==37) keys++;
if (KEY==46) complete=1;
if (KEY==30) clips++;
if (KEY==38) lives++;
if (KEY==35) handmap=1;
if (KEY==50) money+=200;
 */

// vapenkontroll...
      for(i=0;i<4;i++)
	if (KEY==i+2 && ownweapon[i]==1) weapon=i+1;

      if (Lctrl==1) speed=4;
      if (Lalt==1) fire=1;
      if (Aup==1) { up=1; down=0; Adown=0; }
      if (Adown==1) { down=1; up=0; Aup=0; }
      if (Aleft==1) { left=1; right=0; Aright=0; }
      if (Aright==1) { right=1; left=0; Aleft=0; }
/*      if (KEY==71) { left=1; up=1; down=0; right=0; }
      if (KEY==73) { left=0; up=1; down=0; right=1; }
      if (KEY==79) { left=1; up=0; down=1; right=0; }
      if (KEY==81) { left=0; up=0; down=1; right=1; }
*/

      if (fire==1) { ammo=max(0,ammo-2); fired+=2; }
      if (ammo==0 && clips>0) { clips--; ammo=348; }

      if (right==1) { x=x+speed; image=2; }
      if (left==1) { x=x-speed; image=4; }
      if (up==1) { y=y-speed; image=1; }
      if (down==1) { y=y+speed; image=3; }
      if (up==1 && left==1) { image=20; }
      if (up==1 && right==1) { image=17; }
      if (down==1 && left==1) { image=19; }
      if (down==1 && right==1) { image=18; }

      if (keys>0) {
	if (level.cblock(x+7,y)==18 && level.cblock(x+17,y)==18)
	  { level.cchange(x+11,y,27); keys--; }
	if (level.cblock(x+7,y+19)==18 && level.cblock(x+17,y+19)==18)
	  { level.cchange(x+11,y+19,27); keys--; }
	if (level.cblock(x,y+7)==19 && level.cblock(x,y+12)==19)
	  { level.cchange(x,y+9,31); keys--; }
	if (level.cblock(x+23,y+7)==19 && level.cblock(x+23,y+12)==19)
	  { level.cchange(x+23,y+9,31); keys--; }
      }

      bl1=level.cblock(x,y);
      bl2=level.cblock(x+23,y);
      bl3=level.cblock(x,y+19);
      bl4=level.cblock(x+23,y+19);
      if (bl1<52 || bl2<52 || bl3<52 || bl4<52)
	{ x=x1; y=y1; }

      if (((bl1<44 && bl1>39) || (bl2<44 && bl2>39) ||
	 (bl3<44 && bl3>39) || (bl4<44 && bl4>39)) && KEY==56) // Lalt
      {
	computer(x,y);
	up=0; down=0; left=0; right=0; fire=0;
      }

// visa options?
      if (KEY==59) options();


      if (bl1==93 && bl2==94 && bl3==95 && bl4==96 && objective==1)
	{ complete=1; timeleft=1200; }

      if (image==1 && bl1<52 && bl2>52) x=x+2;
      if (image==1 && bl1>52 && bl2<52) x=x-2;
      if (image==3 && bl3<52 && bl4>52) x=x+2;
      if (image==3 && bl3>52 && bl4<52) x=x-2;
      if (image==2 && bl2<52 && bl4>52) y=y+2;
      if (image==2 && bl2>52 && bl4<52) y=y-2;
      if (image==4 && bl1<52 && bl3>52) y=y+2;
      if (image==4 && bl1>52 && bl3<52) y=y-2;

      if (image==17 && bl1<52) x=x+2;
      if (image==17 && bl4<52) y=y-2;
      if (image==18 && bl2<52) y=y+2;
      if (image==18 && bl3<52) x=x+2;
      if (image==19 && bl4<52) x=x-2;
      if (image==19 && bl1<52) y=y+2;
      if (image==20 && bl3<52) y=y-2;
      if (image==20 && bl2<52) x=x-2;

      bl1=level.cblock(x,y);
      bl2=level.cblock(x+23,y);
      bl3=level.cblock(x,y+19);
      bl4=level.cblock(x+23,y+19);

      if (bl1==60 && bl2==60 && bl3==60 && bl4==60)
	rippels=1;
      else
	rippels=0;

      if (bl1==88 || bl2==88 || bl3==88 || bl4==88)
	x=x+speed;
      if (bl1==89 || bl2==89 || bl3==89 || bl4==89)
	x=x-speed;
      if (bl1==90 || bl2==90 || bl3==90 || bl4==90)
	y=y-speed;
      if (bl1==91 || bl2==91 || bl3==91 || bl4==91)
	y=y+speed;

      bl1=level.cblock(x,y);
      bl2=level.cblock(x+23,y);
      bl3=level.cblock(x,y+19);
      bl4=level.cblock(x+23,y+19);

      if (bl1<52 || bl2<52 || bl3<52 || bl4<52)
	{ x=x1; y=y1; }
      if (x!=x1 || y!=y1) add(anim,1,0,15);

// kollar om man plockar upp...
      item=equip.cblock(x+12,y+10);
      if (item==99) money+=200;
      if (item==98) lives++;
      if (item==97) securetycard=1;
      if (item==96) keys++;
      if (item==95) clips++;
      if (item==94) energy=min(energy+100,348);
      if (item>0) equip.cchange(x+12,y+10,0);

// justerar showenergy...
      showenergy=showenergy-(showenergy-energy)/4;

    } while (NOKEY!=129 && energy>0 && complete==0);
    fire=0;
    if (NOKEY==129) {energy=0; showenergy=energy; lives=0;}

    if (complete==0)
    {
      lives--;
      showenergy=0;
      for(bl2=0;bl2<2;bl2++)
	for(bl1=2;bl1<10;bl1++)
	{
	  bl3=bl1;
	  if (bl1==3) bl3=34;
	  if (bl1==5) bl3=36;
	  if (bl1==7) bl3=38;
	  if (bl1==9) bl3=40;
	  drawscreen(image,bl3/2,x,y,h2o,rippels,keys);
	  bl4=fadeout(63,0,0);
	}
      do { delay(1); wait(); } while (fadeout(0,0,0)>0);
      immortal=60; energy=348; showenergy=energy;
    }

    if (complete==1)
    {
      { delay(10); wait(); } while (fadeout(63,63,63)>0);
      bana++;
      if (bana<5) { complete=0; newlevel(x,y); }
    }

    { delay(100); wait(); } while (fadeout(0,0,0)>0);
  } while(lives>-1 && bana<5);

  if (complete==1) finish();
  else gameover();
  killgame();
}

void initgame()
{
  FILE *fp;
  void *p = &GAMESPEED;          /* p points to GSPEED */

  fp=fopen("alien.cfg","rb");
  fread(p,sizeof(GAMESPEED),1,fp);
  fclose(fp);

  byte r,g,b,w;

  mode(19);
  makefont(SYSFNT,FNT);
  loadfont("system.fnt",FNT,PAL);
  makevirt(VR,SCR);
  cls(0,VR);
  makeicons(BLadr,BLblo);
  makeicons(OBadr,OBblo);
  makeicons(PLadr,PLblo);
  loadicons("blocks.icn",BLblo,PAL);
  loadicons("player.icn",PLblo,PAL);
  loadicons("objects.icn",OBblo,PAL);

  recallpalette(PAL);
  fadepalette(PAL,shadowPAL,8);
  for(int i=0;i<16;i++)
    fadeout(0,0,0);
  setcolor(255,63,0,0);
  storepalette(offPAL);
  storepalette(cpuPAL);
  for(i=0;i<240;i++)
  {
    cpuPAL[i][0]=0;
    cpuPAL[i][1]=0;
  }

  recallpalette(PAL);
  for(i=0;i<256;i++)
  {
    getcolor(i,r,g,b);
    w=(r+g+b)/3;
    setcolor(i,w,w,w);
  }
  storepalette(pausPAL);
  recallpalette(PAL);
  for(i=0;i<256;i++)
  {
    getcolor(i,r,g,b);
    setcolor(i,r,g>>2,b>>2);
  }
  storepalette(redPAL);
  setpalette(0,0,0);

  fxy[0][0]=0; fxy[0][1]=-12;
  fxy[1][0]=14; fxy[1][1]=0;
  fxy[2][0]=0; fxy[2][1]=12;
  fxy[3][0]=-14; fxy[3][1]=0;
  fxy[4][0]=9; fxy[4][1]=-9;
  fxy[5][0]=9; fxy[5][1]=9;
  fxy[6][0]=-9; fxy[6][1]=9;
  fxy[7][0]=-9; fxy[7][1]=-9;
}

void newlevel(int &x,int &y)
{
  char fil[13],namn[10];

  if (bana==1) strcpy(namn,"level1");
  if (bana==2) strcpy(namn,"level2");
  if (bana==3) strcpy(namn,"level3");
  if (bana==4) strcpy(namn,"level4");

  strcpy(fil,namn);
  strcat(fil,".equ");
  equip.load(fil);
  strcpy(fil,namn);
  strcat(fil,".map");
  level.load(fil);
  see=level;

  strcpy(fil,namn);
  strcat(fil,".dat");
  ifstream lfil(fil,ios::binary);
  lfil.read((char*)&stuff,sizeof(stuff));
  lfil.close();

  strcpy(fil,namn);
  strcat(fil,".sta");
  ifstream afil(fil,ios::binary);
  afil.read((char*)&x,sizeof(x));
  afil.read((char*)&y,sizeof(y));
  afil.close();
  x=x*24; y=y*20;

  light=1; handmap=0;
  firerate=33; firewall=1;
  objective=1; timeleft=-1;
  if (bana==4) objective=0;
  if (bana==2) light=0;

  briefing();
}

void killgame()
{
  nosound();
  killvirt(SCR);
  killfont(FNT);
  killicons(BLblo);
  killicons(OBblo);
  killicons(PLblo);
  mode(3);
  cout << "Thank you for playing Alien Assault.\n";
  cout << "Plase send your comments to: peitz@hotmail.com\n\n";

  FILE *fp;
  void *p = &GAMESPEED;          /* p points to GSPEED */

  fp=fopen("alien.cfg","wb");
  fwrite(p,sizeof(GAMESPEED),1,fp);
  fclose(fp);
}

void drawscreen(int ir,int i,int tx,int ty,int water,int r,int ke)
{
  int x,y,ox,oy,ax,ay,fx,fy,bl,sx,sy,xx,yy;

  ox=tx/24;
  oy=ty/20;
  ax=tx-(ox<<3)-(ox<<4);
  ay=ty-(oy<<2)-(oy<<4);

  cls(0,VR);

  for(x=14;x>-1;x--)
    for(y=0;y<11;y++) {
      xx=x+ox-6; yy=y+oy-4;
      if (xx>=0 && xx<40 && yy>=0 && yy<40)
      {
	bl=level.block(xx,yy);
	if(bl==46 || bl==47 || bl==48 || bl==49)
	  if(eggenergy<0) { level.change(xx,yy,59); objective=1; }
	if(bl==30) level.change(xx,yy,82);
	if(bl==34) level.change(xx,yy,83);
	bl=level.block(xx,yy);
	if(bl>26 && bl<34) level.change(xx,yy,bl+1);
	if(bl>34 && bl<39) level.change(xx,yy,bl+1);
	if(bl==38) level.change(xx,yy,35);
	puticon(level.block(xx,yy),(x<<3)+(x<<4)-ax,(y<<2)+(y<<4)-ay,VR,BLadr);
	if (equip.block(xx,yy)>0)
	  puticon_M(equip.block(xx,yy),(x<<3)+(x<<4)-ax,(y<<2)+(y<<4)-ay,VR,OBadr);
      }
    }

  if (r==1) puticon_M(water,144,80,VR,PLadr);

  for(int j=0;j<100;j++)
  {
    if (stuff[j].exist==0)
    {
      sx=144+stuff[j].x-tx;
      sy=80+stuff[j].y-ty;
      puticon_M(stuff[j].dead+stuff[j].type*39,sx,sy,VR,OBadr);
    }
  }

  for(j=0;j<100;j++)
  {
    if (stuff[j].exist==1)
    {
      sx=144+stuff[j].x-tx;
      sy=80+stuff[j].y-ty;
      puticon_M(stuff[j].image,sx,sy,VR,OBadr);
    }
  }

  if (visible==1) puticon_M(i,144,80,VR,PLadr);

  if (hurt==1 && immortal==0)
  {
    add(hrate,1,53,57);
    puticon_M(hrate,144,80,VR,PLadr);
  }

  if (ir>4) ir=ir-12;
  if (fire==1 && ammo>0)
  {
    add(frat,1,0,1);
    add(firerate,1,33,36);
    puticon_M(44+ir+frat*13,144+fxy[ir-1][0],80+fxy[ir-1][1],VR,PLadr);
    if (checkhit(tx+12,ty+10,ir,x,y)==1)
      puticon_M(firerate,170+x,102+y,VR,PLadr);
  }

// ritar ut statusbaren

  for(j=0;j<13;j++)
    puticon(79+j,(j<<4)+(j<<3),180,VR,OBadr);
  puticon(94+weapon,111,180,VR,PLadr);
  if (securetycard==0) puticon(92,296,180,VR,OBadr);
  else puticon(93,296,180,VR,OBadr);

  if (timeleft>0) horizontal(10,199,timeleft>>2,128,VR);

  if (energy>0) horizontal(24,186,showenergy>>2,128,VR);
  for(int k=0;k<lives;k++)
  {
    putpixel(24+(k<<1),192,131,VR);
    putpixel(24+(k<<1),193,128,VR);
  }
  if (ammo>0) horizontal(134,186,ammo>>2,89,VR);
  for(k=0;k<clips;k++)
  {
    putpixel(134+(k<<1),192,88,VR);
    putpixel(134+(k<<1),193,83,VR);
  }
  for(k=0;k<ke;k++)
  {
    putpixel(243+(k<<1),189,103,VR);
    putpixel(243+(k<<1),190,101,VR);
  }

  if (handmap==1)	// ritar upp en karta
  {
    for(x=0;x<40;x++)
      for(y=0;y<40;y++)
	if (level.block(x,y)<53)
	  putpixel(10+x,10+y,90,VR);
    putpixel(10+ox,10+oy,31,VR);
  }

  movealiens(tx,ty);
  wait();
  screencopy(VR,VGA);
}

void credits()
{
  pal PAL1;
  int i,ky;

  randomize();
  setpalette(0,0,0);
  loadeci("crowfoot.eci",VGA,PAL1);
  do { delay(10); wait(); } while (fadein(PAL1)>0 && KEY!=1);
  if (KEY!=1)
    i=0;
    do {
      if (KEY==1) i=1500;
      delay(1);
      i++;
    } while (i<1500);
    if (KEY!=1)
      do { delay(10); wait(); } while (fadeout(0,0,0)>0 && KEY!=1);
      if (KEY!=1)
	loadeci("presents.eci",VGA,PAL1);
	do { delay(10); wait(); } while (fadein(PAL1)>0 && KEY!=1);
	if (KEY!=1)
	  i=0;
	  do {
	    delay(1);
	    if (KEY==1) i=1500;
	    i++;
	  } while (i<1500);

  do { delay(10); wait(); } while (fadeout(0,0,0)>0);
}

int title()
{
  int k;
  randomize();

  pal PAL;

  loadcel("title.cel",VGA2,PAL);

  do { delay(1); } while (fadein(PAL)>0);

  k=KEY;
  do { k=KEY; } while(k!=1 && k!=57);

  do { delay(1); } while (fadeout(63,63,63)>0);
  do { delay(5); } while (fadeout(0,0,0)>0);
  cls(0,VGA);
  return (k);
}