#ifndef _MAP_
#define _MAP_

#include<stdio.h>

typedef unsigned char byte;
typedef unsigned int word;
typedef byte maptyp[40][40];

const size=40;

class map
{
  public:
    map();
    ~map();
    int block(int x,int y);	        // returnerar blocket i (x,y)
    int cblock(int x,int y);	        // returnerar blocket i kord(x,y)
    void change(int x,int y,int b);     // byter till b i (x,y)
    void cchange(int x,int y,int b);    // byter till b i kord(x,y)
    void save(char *fnamn);     	// sparar
    void load(char *fnamn);     	// hmtar
    void fill(int b);			// fyller kartan med b
  private:
    maptyp karta;
};

#endif

map::map()
{
}

map::~map()
{
}

int map::block(int x,int y)
{
  return(karta[x][y]);
}

int map::cblock(int x,int y)
{
  return(karta[x/24][y/20]);
}

void map::change(int x,int y,int b)
{
  karta[x][y]=b;
}

void map::cchange(int x,int y,int b)
{
  karta[x/24][y/20]=b;
}

void map::save(char *fnamn)
{
  FILE *fp;

  fp=fopen(fnamn,"wb");
  fwrite(karta,1600,1,fp);
  fclose(fp);
}

void map::load(char *fnamn)
{
  FILE *fp;

  fp=fopen(fnamn,"rb");
  fread(karta,1600,1,fp);
  fclose(fp);
}

void map::fill(int b)
{
  for(int x=0;x<size;x++)
    for(int y=0;y<size;y++)
      karta[x][y]=b;
}

