#include <stdlib.h>
#include <conio.h>
#include <iostream.h>
#include <fstream.h>
#include <string.h>

#include "gfx.cpp"
#include "map.cpp"
#include "object.cpp"

void drawit(int ox,int oy);

map floor;

word ICON;
byte far *iblk;

word VR;
byte far *SCR;

void main()
{
  mode(19);

  floor.load("new.map");

  char ky;
  pal PAL;
  int cx=0,sx=19,x,y;
  int cy=0,sy=19;
  int ofx=0;
  int ofy=0;
  int bl=1;
  int blk;
  int hold=0;
  char namn[15],fil[15];

  makeicons(ICON,iblk);
  loadicons("blocks.icn",iblk,PAL);
  recallpalette(PAL);

  makevirt(VR,SCR);

  do {
    drawit(ofx,ofy);
    puticon(bl,(cx-ofx)*24,(cy-ofy)*20,VGA,ICON);
    if (sx>=ofx && sx<=ofx+12 && sy>=ofy && sy<=ofy+9)
      box((sx-ofx)*24,(sy-ofy)*20,(sx-ofx)*24+23,(sy-ofy)*20+19,254,VGA);
    box((cx-ofx)*24,(cy-ofy)*20,(cx-ofx)*24+23,(cy-ofy)*20+19,255,VGA);

    ky=getch();
    if (ky==72) cy--;
    if (ky==80) cy++;
    if (ky==75) cx--;
    if (ky==77) cx++;
    if (cx<0) cx=0;
    if (cy<0) cy=0;
    if (cx>size-1) cx=size-1;
    if (cy>size-1) cy=size-1;
    if (ky=='h') hold++;
    if (ky==32 | hold==1) floor.change(cx,cy,bl);
    if (ky=='d' && floor.block(cx,cy)==6) floor.change(cx,cy,18);
    if (ky=='d' && floor.block(cx,cy)==7) floor.change(cx,cy,19);
    if (hold==2) hold=0;
    if (ky=='z') bl--;
    if (ky=='x') bl++;
    if (bl<1) bl=100;
    if (bl>100) bl=1;
    if (ky=='p') bl=floor.block(cx,cy);
    if (ky=='b') { sx=cx; sy=cy;}
    if (cx<ofx) ofx--;
    if (cx>ofx+12) ofx++;
    if (cy<ofy) ofy--;
    if (cy>ofy+9) ofy++;

    if (ky=='N') floor.load("new.map");
    if (ky=='F')
    {
      mode(3);
      cout << "FILLBLOCK: ";
      cin >> blk;
      floor.fill(blk);
      mode(19);
      recallpalette(PAL);
    }
    if (ky=='R')
    {
      for(x=0;x<40;x++)
	for(y=0;y<40;y++)
	  if (floor.block(x,y)==54 || floor.block(x,y)==56 || floor.block(x,y)==57)
	  {
	    floor.change(x,y,54+random(3));
	    if (floor.block(x,y)==55)
	      floor.change(x,y,57);
	  }
    }
    if (ky=='s')
    {
      for(x=0;x<40;x++)
	for(y=0;y<40;y++)
	  if (floor.block(x,y)<52) putpixel(10+x,10+y,31,VGA);
      getch();
    }
    if (ky=='L')
    {
      mode(3);
      cout << "LOADFILE: ";
      cin.getline(namn,15);
      strcpy(fil,namn);
      strcat(fil,".map");
      floor.load((char*)fil);

    strcpy(fil,namn);
    strcat(fil,".sta");
    ifstream lfil(fil,ios::binary);
    lfil.read((char*)&sx,sizeof(sx));
    lfil.read((char*)&sy,sizeof(sy));
    lfil.close();

      mode(19);
      recallpalette(PAL);
    }
    if (ky=='S')
    {
      mode(3);
      cout << "SAVEFILE: ";
      cin.getline(namn,15);
      strcpy(fil,namn);
      strcat(fil,".map");
      floor.save((char*)fil);

    strcpy(fil,namn);
    strcat(fil,".sta");
    ofstream sfil(fil,ios::binary);
    sfil.write((char*)&sx,sizeof(sx));
    sfil.write((char*)&sy,sizeof(sy));
    sfil.close();

      mode(19);
      recallpalette(PAL);
    }

  } while (ky!=27);

  killicons(iblk);
  killvirt(SCR);
  mode(3);
}

void drawit(int ox,int oy)
{
  for(int x=12;x>-1;x--)
    for(int y=0;y<10;y++)
      puticon(floor.block(x+ox,y+oy),x*24,y*20,VR,ICON);
  screencopy(VR,VGA);
}