#include <conio.h>
#include <stdlib.h>
#include <iostream.h>
#include <fstream.h>

#include "gfx.cpp"
#include "map.cpp"
#include "object.cpp"

void drawit(int ox,int oy);

map floor;
object stuff[100];

word BICON;
byte far *bblk;
word OICON;
byte far *oblk;

word VR;
byte far *SCR;

void main()
{
  char ky;
  pal PAL;
  int obj=0;
  int cx=0;
  int cy=0;
  int ofx=0;
  int ofy=0;
  char namn[15];
  FILE *fp;
  int i;

  cout << "LOADMAP: ";
  cin.getline(namn,15);
  floor.load((char*)namn);

  mode(19);

  makeicons(BICON,bblk);
  loadicons("blocks.icn",bblk,PAL);
  makeicons(OICON,oblk);
  loadicons("objects.icn",oblk,PAL);
  recallpalette(PAL);

  makevirt(VR,SCR);

  do {
    drawit(ofx,ofy);
    box((cx-ofx)*24,(cy-ofy)*20,(cx-ofx)*24+23,(cy-ofy)*20+19,63,VGA);

    ky=getch();
    if (ky==72) cy--;
    if (ky==80) cy++;
    if (ky==75) cx--;
    if (ky==77) cx++;
    if (cx<0) cx=0;
    if (cy<0) cy=0;
    if (cx>size-1) cx=size-1;
    if (cy>size-1) cy=size-1;
    if (cx<ofx) ofx--;
    if (cx>ofx+12) ofx++;
    if (cy<ofy) ofy--;
    if (cy>ofy+9) ofy++;
    if (ky==32 && obj<100) {
      gotoxy(0,0);
      cout << obj << " Object nr: ";
      cin >> stuff[obj].image;
      if (stuff[obj].image!=0) {
	stuff[obj].exist=1;
	stuff[obj].x=cx;
	stuff[obj].y=cy;
	obj++;
      }
    }

    if (ky=='L')
    {
      mode(3);
      cout << "LOADOBJ: ";
      cin.getline(namn,15);
      ifstream lfil(namn,ios::binary);
      lfil.read((char*)&stuff,sizeof(stuff));
      lfil.close();
      mode(19);
      recallpalette(PAL);
    }
    if (ky=='S')
    {
      randomize();
      for(int i=0;i<100;i++)
      {
	stuff[i].exist=1;
	stuff[i].dead=0;
	stuff[i].anim=0;
	stuff[i].type=random(3);
	if (stuff[i].type>1) stuff[i].type=1;
	stuff[i].speed=1;
	if (stuff[i].type==0) stuff[i].speed=2;
	stuff[i].energy=15;
	if (stuff[i].type==0) stuff[i].energy=6;

	do {
	  stuff[i].x=random(40);
	  stuff[i].y=random(40);
	} while (floor.block(stuff[i].x,stuff[i].y)<52 || floor.block(stuff[i].x,stuff[i].y)==60);
	stuff[i].x=stuff[i].x*24;
	stuff[i].y=stuff[i].y*20;
	stuff[i].image=random(4)+1;
	stuff[i].rikt=stuff[i].image;
      }
      mode(3);
      cout << "SAVEOBJ: ";
      cin.getline(namn,15);
      ofstream sfil(namn,ios::binary);
      sfil.write((char*)&stuff,sizeof(stuff));
      sfil.close();
      mode(19);
      recallpalette(PAL);
    }

  } while (ky!=27);

  killicons(bblk);
  killicons(oblk);
  killvirt(SCR);
  mode(3);
}

void drawit(int ox,int oy)
{
  for(int x=12;x>-1;x--)
    for(int y=0;y<10;y++)
      puticon(floor.block(x+ox,y+oy),x*24,y*20,VR,BICON);
  for(int i=0;i<100;i++)
    if (stuff[i].exist==1) {
      x=stuff[i].x;
      y=stuff[i].y;
      if (x>=ox && x<=ox+12 && y>=oy && y<=oy+9)
	puticon_M(stuff[i].image,(x/24-ox)*24,(y/20-oy)*20,VR,OICON);
    }

  screencopy(VR,VGA);
}