#include <conio.h>
#include <string.h>
#include <iostream.h>

#include "gfx.cpp"
#include "map.cpp"
#include "object.cpp"

void drawit(int ox,int oy);

map floor;
map equip;

word ICON;
byte far *iblk;
word EQU;
byte far *eblk;

word VR;
byte far *SCR;

void main()
{
  mode(19);

  floor.load("new.map");
  equip.fill(0);

  char ky;
  pal PAL;
  int cx=0;
  int cy=0;
  int ofx=0;
  int ofy=0;
  int bl=1;
  int blk;
  int hold=0;
  char namn[15];
  char fil[15];

  makeicons(ICON,iblk);
  loadicons("blocks.icn",iblk,PAL);
  makeicons(EQU,eblk);
  loadicons("objects.icn",eblk,PAL);
  recallpalette(PAL);

  makevirt(VR,SCR);

  do {
    drawit(ofx,ofy);
    if (bl>0) puticon_M(bl,(cx-ofx)*24,(cy-ofy)*20,VGA,EQU);
    box((cx-ofx)*24,(cy-ofy)*20,(cx-ofx)*24+23,(cy-ofy)*20+19,255,VGA);

    ky=getch();
    if (ky==72) cy--;
    if (ky==80) cy++;
    if (ky==75) cx--;
    if (ky==77) cx++;
    if (cx<0) cx=0;
    if (cy<0) cy=0;
    if (cx>size-1) cx=size-1;
    if (cy>size-1) cy=size-1;
    if (ky=='h') hold++;
    if (ky==32 | hold==1) equip.change(cx,cy,bl);
    if (hold==2) hold=0;
    if (ky=='z') bl--;
    if (ky=='x') bl++;
    if (bl<0) bl=100;
    if (bl>100) bl=0;
    if (ky=='p') bl=equip.block(cx,cy);
    if (ky=='0') bl=0;
    if (cx<ofx) ofx--;
    if (cx>ofx+12) ofx++;
    if (cy<ofy) ofy--;
    if (cy>ofy+9) ofy++;

    if (ky=='N') equip.fill(0);
    if (ky=='L')
    {
      mode(3);
      cout << "LOADFILE: ";
      cin.getline(namn,15);
      strcpy(fil,namn);
      strcat(fil,".map");
      floor.load((char*)fil);
      strcpy(fil,namn);
      strcat(fil,".equ");
      equip.load((char*)fil);
      mode(19);
      recallpalette(PAL);
    }
    if (ky=='S')
    {
      mode(3);
      cout << "SAVEFILE: ";
      cin.getline(namn,15);
      strcpy(fil,namn);
      strcat(fil,".equ");
      equip.save((char*)fil);
      mode(19);
      recallpalette(PAL);
    }

  } while (ky!=27);

  killicons(iblk);
  killvirt(SCR);
  mode(3);
}

void drawit(int ox,int oy)
{
  for(int x=12;x>-1;x--)
    for(int y=0;y<10;y++)
    {
      puticon(floor.block(x+ox,y+oy),x*24,y*20,VR,ICON);
      if (equip.block(x+ox,y+oy)>0)
	puticon_M(equip.block(x+ox,y+oy),x*24,y*20,VR,EQU);
    }
  screencopy(VR,VGA);
}