
//   		       	   *** B I G   N O T E ***

// NOTHING IN THIS FILE MAY BE USED WITHOUT GIVING ALL CREDIT TO JOHAN PEITZ

#include <dos.h>

#define KEYINTR 0X09    /* The Keyboard interrupt */

#ifdef __cplusplus
  #define __CPPARGS ...
#else
  #define __CPPARGS
#endif

int NOKEY=0,KEY=0,Aup=0,Adown=0,Aleft=0,Aright=0;
int Lctrl=0, Lshift=0, Lalt=0;
void interrupt ( *oldhandler)(__CPPARGS);

void interrupt handler(__CPPARGS)
{
  KEY = inportb(96);
  if (KEY>128) NOKEY=KEY;

  if (KEY==75) Aleft=1;
  if (KEY==77) Aright=1;
  if (KEY==72) Aup=1;
  if (KEY==80) Adown=1;
  if (KEY==200) Aup=0;
  if (KEY==208) Adown=0;
  if (KEY==203) Aleft=0;
  if (KEY==205) Aright=0;

  if (KEY==29) Lctrl=1;
  if (KEY==42) Lshift=1;
  if (KEY==56) Lalt=1;
  if (KEY==157) Lctrl=0;
  if (KEY==170) Lshift=0;
  if (KEY==184) Lalt=0;

  outportb(32,32);
}

void saveoldhandler();
void newhandler();
void restorehandler();

void saveoldhandler()
{
  oldhandler = getvect(KEYINTR);
}

void newhandler()
{
  setvect(KEYINTR, handler);
}

void restorehandler()
{
  setvect(KEYINTR, oldhandler);
}

